<script setup lang="ts">
import DeleteModal from "@/components/modals/DeleteModal.vue";
import type { BucketPermissionOut } from "@/client/types.gen.ts";
import { useNameStore } from "@/stores";

const props = defineProps<{
  modalId: string;
  permission?: BucketPermissionOut;
  backModalId?: string;
}>();

const nameRepository = useNameStore();

const emit = defineEmits<{
  (e: "confirm-delete", permission: BucketPermissionOut): void;
}>();

function deletePermission() {
  if (props.permission != undefined) {
    emit("confirm-delete", props.permission);
    window._paq?.push(["trackEvent", "Delete", "permission"]);
  }
}
</script>

<template>
  <delete-modal
    :modal-id="props.modalId"
    :back-modal-id="props.backModalId"
    delete-type="Bucket Permission"
    :disabled="props.permission == undefined"
    @confirm-delete="deletePermission"
  >
    <template #body>
      <p>
        Are you sure you want to delete the bucket permission for
        <strong v-if="props.permission">{{
          nameRepository.getName(props.permission.uid)
        }}</strong>
        to the bucket
        <strong v-if="props.permission">{{
          props.permission.bucket_name
        }}</strong
        >?
      </p>
    </template>
  </delete-modal>
</template>

<style scoped></style>
